#!/usr/bin/perl

#
# Script para inversão do elemento *pro* com os elementos CODE, *T* e CONJ, 
# que ficaram em posição incorreta, após a inclusão de *pro*.
#
# Autor: Pablo Picasso F. de Faria
# Em 12/11/2007
#

# Verifica parâmetros
if(scalar(@ARGV) != 1) {
   print "\nScripts do Corpus Tycho Brahe, IEL/Unicamp (2008)\n";
   print "Autor: Pablo Faria (pablofaria\@gmail.com)\n\n";
   print "Uso:\n    tb-PSDtoPOS.pl <psdfile>\n";
   print "Saída:\n    <psdfile>_pos.txt\n\n";
   exit;
}

$fin  = $ARGV[0];
$fout = $ARGV[0]."_pos.txt";

open(ARQ, "<$fin") || die;
open(DADOS1, ">$fout") || die;

print DADOS1 "#!FORMAT=POS_0\n\n<text>\n\n";

# Varre o arquivo, linha a linha
while($linha = <ARQ>) {
   # Processa cada par (tag word) encontrado na linha
   while ($linha =~ /\(([^()%]+)\)/) {
      $aux  = $1;
      $aux  =~ /([^ ]*) ([^ ]*)/;
      $word = $2;
      $tag  = $1;

      # Desfaz adaptações feitas pelo parser
      if(($word eq "OPEN")  && ($tag eq ",")) { $word = "("; }
      if(($word eq "CLOSE") && ($tag eq ",")) { $word = ")"; }

      # Monta a sequência 'word/tag'
      $pos1 = $word."/".$tag." ";
      if($tag eq "ID") { $pos1 .= "./PONFP\n\n"; }
      if($tag eq "CODE") { $pos1 .= "\n\n"; }

      # Exporta apenas palavras, itens sintáticos acrescentados pelo parser são descartados
      if(($word =~ /./) && 
         ($word !~ /(\*pro\*|\*ICH\*|\*T\*|\*exp\*|\*EXP\*|\*con\*|\*-)/) && 
         ($word ne "*")) {
         # Imprime a nova linha no arquivo
         print DADOS1 $pos1;
      }

      $linha =~ s/\([^()%]+\)//;
   }
}

print DADOS1 "</text>";
