#!/usr/bin/perl
# use strict; use warnings;

# Este script faz a inclusão de IDs de sentença em arquivos sintaticamente
# anotados.

# Verifica parâmetros
if(scalar(@ARGV) != 1) {
   print "\nScripts do Corpus Tycho Brahe, IEL/Unicamp (2008)\n";
   print "Autor: Pablo Faria (pablofaria\@gmail.com)\n\n";
   print "Uso:\n    tb-addID.pl <psdfile>\n";
   print "Saída:\n    STDOUT\n\n";
   exit;
}

# part of re-ref
# adds base of filename as ID and page and token numbers
# note that scripts relies on blank lines between tokens to work

$/ = "";
# $* = 1;                       # multi-line matching (deprecated)

$filename = shift(@ARGV);       # assign first arg to $filename
$count = 0;

($name, $rest) = split(/\./, $filename); # get base of filename

($NAME = $name) =~ tr/a-z/A-Z/; # capitalize it

open(FILENAME, "$filename");    # open input file

while (<FILENAME>) {
   if (/<P_([^>]*)>/) {	# aires format for page references - this line will have to be revised for other formats; remember parens around page variable!
      $page = $1;            # assign page number to PN
   }
   if (/\)\)\)\n\n/) {
      $count++;			# increment counter
      s/\)\)\)\n\n/\)\) \(ID $NAME,$page.$count\)\)\n\n/; # add ID
   } elsif (/\)\)\)\n*$/) { # fix to process the last sentence
      $count++;                 # increment counter
      s/\)\)\)\n*$/\)\) \(ID $NAME,$page.$count\)\)\n\n/; # add ID
   }
   print;
}
