#!/usr/bin/perl

#
# Script para processar um arquivo "preparse"
# e gerar uma versão hierárquica "flat" para posterior análise sintática 
# manual, através do CorpusDraw (inserindo parênteses rotulados).
#
# Autor: Pablo Picasso F. de Faria
# Criação: 18/09/2009
#

# Verifica parâmetros
if(scalar(@ARGV) != 1) {
   print "\nScripts do Corpus Tycho Brahe, IEL/Unicamp (2009)\n";
   print "Autor: Pablo Faria (pablofaria\@gmail.com)\n\n";
   print "Uso:\n    tb-assignFlatTree.pl <preparse-file>\n";
   print "Saída:\n    <preparse-file>.parsed\n\n";
   exit;
}

$fin  = $ARGV[0];
$fout = $ARGV[0].".parsed";

open(ARQ, "<$fin") || die;
open(DADOS, ">$fout") || die;

# Processamento
while($linha = <ARQ>) {
   $linha =~ s/^\(\(/(/g;   # Remove ( inicial
   $linha =~ s/\)\)$/)/g;   # Remove ) final
   $linha =~ s/\(([^ ]+) \(([^)]+)\)\)/($2 $1)/g;   # Converte "(word (tag))" para "(tag word)"
   $linha = "(IP-XXX ".$linha.")";   # Insere IP-XXX para dominar todos os nós
   print DADOS $linha;
}

close(ARQ);
close(DADOS);
