#!/usr/bin/perl

#
# Substitui a notação de parênteses por colchetes (com isto, a árvore pode ser
# exibida no PHPSyntaxTree (http://www.tycho.iel.unicamp.br/phpsyntaxtree/).
#
# Autor: Pablo Picasso F. de Faria
# Criação: 18/09/2008
#

# Verifica parâmetros
if(scalar(@ARGV) != 1) {
   print "\nScripts do Corpus Tycho Brahe, IEL/Unicamp (2008)\n";
   print "Autor: Pablo Faria (pablofaria\@gmail.com)\n\n";
   print "Uso:\n    tb-bracketIt.pl <psdfile>\n";
   print "Saída:\n    <psdfile>.colchetes\n\n";
   exit;
}

$fin  = $ARGV[0];
$fout = $ARGV[0].".colchetes";

open(ARQ, "<$fin") || die;
open(DADOS, ">$fout") || die;

print STDOUT "Processando...";

# Processamento
while($linha = <ARQ>) {
   $linha =~ s/\(/[/g;
   $linha =~ s/\)/]/g;
   $linha =~ s/^\[ \[(.*?)\]\]\n/[$1]\n/;  # Retira colchetes extras (do CorpusDraw)
   print DADOS $linha; 
}

print STDOUT "Ok!\n";

close(ARQ);
close(DADOS);
