#!/usr/bin/perl -w

# Este script faz a adaptação da primeira versão dos XMLs do E-Dictor
# para a versão mais compacta utilizada atualmente.

# Verifica parâmetros
if(scalar(@ARGV) != 1) {
   print "\nScripts do Corpus Tycho Brahe, IEL/Unicamp (2008)\n";
   print "Autor: Pablo Faria (pablofaria\@gmail.com)\n\n";
   print "Uso:\n    tb-changeTags.pl <xmlfile>\n";
   print "Saída:\n    <xmlfile>.new\n\n";
   exit;
}

$fin  = $ARGV[0];
open(ARQ, "<$fin") || die;
open(DADOS, ">$fin.new") || die;

# Carrega todo o arquivo em um buffer
$buffer = "";
while($linha = <ARQ>) {
   $buffer .= $linha;
}

# Para facilitar a substituição
$buffer =~ s/\n/<br>/g;


# Troca das tags
$buffer =~ s/<(\/?)name>/<$1n>/g;
$buffer =~ s/<(\/?)val>/<$1v>/g;
$buffer =~ s/<(\/?)sec_el(.*?)>/<$1sce$2>/g;
$buffer =~ s/<(\/?)sec(.*?)>/<$1sc$2>/g;
$buffer =~ s/<(\/?)text_el(.*?)>/<$1te$2>/g;
$buffer =~ s/<(\/?)or(.*?)>/<$1o$2>/g;
$buffer =~ s/<(\/?)ed(.*?)>/<$1e$2>/g;
$buffer =~ s/<(\/?)morf(.*?)>/<$1m$2>/g;
$buffer =~ s/<(\/?)fon(.*?)>/<$1f$2>/g;
$buffer =~ s/<(\/?)break(.*?)>/<$1bk$2>/g;
$buffer =~ s/lang=/l=/g;
$buffer =~ s/format=/f=/g;
$buffer =~ s/pos=/v=/g;
$buffer =~ s/["']line_nr["']/"ln"/g;
$buffer =~ s/["']p_nr["']/"pn"/g;
$buffer =~ s/["']page_nr["']/"pgn"/g;
$buffer =~ s/["']line["']/"l"/g;
$buffer =~ s/["']page["']/"p"/g;
$buffer =~ s/["']column["']/"c"/g;
$buffer =~ s/["']footnote["']/"ft"/g;
$buffer =~ s/["']character["']/"cht"/g;
$buffer =~ s/["']enum["']/"enm"/g;

# Coloca de volta os saltos de linha
$buffer =~ s/<br>/\n/g;

print DADOS $buffer;
