#!/usr/bin/perl

#
# Fix postparse problems (based on what I saw there and the comments from Beatrice).
#
# Autor: Pablo Picasso F. de Faria
# Criação: 28/08/2009
#

# Verifica parâmetros
if(scalar(@ARGV) != 1) {
   print "\nScripts do Corpus Tycho Brahe, IEL/Unicamp (2008)\n";
   print "Autor: Pablo Faria (pablofaria\@gmail.com)\n\n";
   print "Uso:\n    tb-fixPages.pl <parsedfile>\n";
   print "Saída:\n    <parsedfile>.psd\n\n";
   exit;
}

$fin  = $ARGV[0];
$fout = $ARGV[0].".tmp";

open(ARQ, "<$fin") || die;
open(DADOS, ">$fout") || die;

print STDOUT "Processando...";

# Varre o arquivo, concatenando as linhas em um buffer único
$newoutput = "";
while($linha = <ARQ>) {
   $linha =~ s/\s+$//;
   if($linha =~ /[\w\d]/) {
      $newoutput .= " ".$linha."<\@bk><\@bk>";
   }
}

# Processamento
$bodyoutput = "( ";
while ($newoutput =~ /(\(CODE <P_[0-9]+>\))(.*?)(\(CODE <P_[0-9]+>\))/) {
   $bodyoutput .= $3.$2;

   #print STDOUT $1."<".$3;

   # Consume buffer
   $newoutput =~ s/(\(CODE <P_[0-9]+>\))(.*?)(\(CODE <P_[0-9]+>\))/$3/;
}

$bodyoutput =~ s/<\@bk><\@bk> \( $//g;   # Fix: ^( $
$bodyoutput =~ s/<\@bk><\@bk> /\n\n/g;
#$bodyoutput =~ s/^(\(CODE <P_[0-9]+>\)\))/( $1/g;   # Fix: ^(CODE <P_222>)) to ^( (CODE ...))

print DADOS $bodyoutput;
print STDOUT "Ok!\n";

close(ARQ);
close(DADOS);
