#!/usr/bin/perl

#
# Fix postparse problems (based on what I saw there and the comments from Beatrice).
#
# Autor: Pablo Picasso F. de Faria
# Criação: 28/08/2009
#

# Verifica parâmetros
if(scalar(@ARGV) != 1) {
   print "\nScripts do Corpus Tycho Brahe, IEL/Unicamp (2008)\n";
   print "Autor: Pablo Faria (pablofaria\@gmail.com)\n\n";
   print "Uso:\n    tb-fixPostParse.pl <parsedfile>\n";
   print "Saída:\n    <parsedfile>.psd\n\n";
   exit;
}

$fin  = $ARGV[0];
$fout = $ARGV[0].".psd";

open(ARQ, "<$fin") || die;
open(DADOS, ">$fout") || die;

print STDOUT "Processando...";

# Processamento
while($linha = <ARQ>) {
    $aux = $linha;
    $aux =~ s/[ \n]//g;
    # Discard empty lines or "null" parses (sentences with only punctuation marks)
    if ($aux ne "") {
        $linha =~ s/\n//g;
        $linha =~ s/(\w+) \+unknown\+ /FRAG /g;
        $linha =~ s/\( \(FRAG \(CODE <P_([0-9]+)>\)\)\)/( (CODE <P_$1>))/g;
        $linha =~ s/^/( /g;
        $linha =~ s/$/)\n\n/g;
        if ($linha !~ /\Wnull\W/) {
            print DADOS $linha;
        }
    }
}

print STDOUT "Ok!\n";

close(ARQ);
close(DADOS);
