#!/usr/bin/perl -w

# Este script lista as tags presentes em um arquivo XML qualquer.

# Verifica parâmetros
if(scalar(@ARGV) != 1) {
   print "\nScripts do Corpus Tycho Brahe, IEL/Unicamp (2008)\n";
   print "Autor: Pablo Faria (pablofaria\@gmail.com)\n\n";
   print "Uso:\n    tb-listTags.pl <xmlfile>\n";
   print "Saída:\n    STDOUT\n\n";
   exit;
}

$fin  = $ARGV[0];
open(ARQ, "<$fin") || die;

@tags = ("     <text>\n");
while($linha = <ARQ>) {
   $linha =~ s/\n/ /g;

   while ($linha =~ /(<([^>]*?)>)/) {
      if (!grep(/$1/,@tags)) {
         push(@tags,"     ".$1."\n");
      }
      $linha =~ s/(<([^>]*?)>)//;
   }
}

print "Lista de tags presentes no arquivo XML:\n\n";
print sort(@tags);
