#!/usr/bin/perl

#
# Script para processar um arquivo etiquetado (no formato de busca com 
# CorpusSearch) e gerar uma versão hierárquica básica para iniciar uma 
# análise sintática manual, através do CorpusDraw (inserindo parênteses 
# rotulados).
#
# Autor: Pablo Picasso F. de Faria
# Criação: 18/09/2008
#

# Verifica parâmetros
if(scalar(@ARGV) != 1) {
   print "\nScripts do Corpus Tycho Brahe, IEL/Unicamp (2008)\n";
   print "Autor: Pablo Faria (pablofaria\@gmail.com)\n\n";
   print "Uso:\n    tb-posToFlatPSD.pl <posfile>\n";
   print "Saída:\n    <posfile>.psd\n\n";
   exit;
}

$fin  = $ARGV[0];
$fout = $ARGV[0].".psd";

open(ARQ, "<$fin") || die;
open(DADOS, ">$fout") || die;

print STDOUT "Processando...";

# Processamento
while($linha = <ARQ>) {
   if($linha =~ /FORMAT/ || $linha =~ /text>/) { next; }

   $linha =~ s/ *\n/\n/;
   if ($linha ne "\n") {
      $linha =~ s/^/( /;
      $linha =~ s/\n/ )\n\n/;
      $linha =~ s/([^ ]+)\/([^ ]+)/($2 $1)/g;
      $linha =~ s/\(\( \(\)/(X <LPAREN>)/g;
      $linha =~ s/\(\( \)\)/(X <RPAREN>)/g;
      $linha =~ s/\(\( -\)/(X -)/g;
      $linha =~ s/ \(PONFP \.\)//;
      $linha =~ s/CONJS/C/g;
      if ($linha !~ /^\( \(CODE/) {
         $linha =~ s/^\( (.*?) (\(ID [^ ]+\)) \)\n\n/\( \(IP $1\) $2\)\n\n/; }
      print DADOS $linha; 
   }
}

print STDOUT "Ok!\n";

close(ARQ);
close(DADOS);
