#!/usr/bin/perl
# use strict; use warnings

# Este script faz a remoção de IDs das sentenças em um arquivo sintaticamente
# anotado.

# Verifica parâmetros
if(scalar(@ARGV) != 1) {
   print "\nScripts do Corpus Tycho Brahe, IEL/Unicamp (2008)\n";
   print "Autor: Pablo Faria (pablofaria\@gmail.com)\n\n";
   print "Uso:\n    tb-rmID.pl <psdfile>\n";
   print "Saída:\n    STDOUT\n\n";
   exit;
}

# part of re-ref
# removes IDs in files
# new IDs are added by add-id.prl

$/ = "";

while (<>) {
   s/(\(ID([^\)]+)\))//gm;                 # get id for type (ID XXX)
   s/\)[\t\s]*\n*[\t\s*]\)/\)\)/gm;        # delete space left by ID
   s/\)\n\)/\)\)/gm;                       # delete space left by ID, again
   print;
}

