#!/usr/bin/perl

#
# Script split de arquivo pre-parseado (na UPenn) em sentenças unitárias 
# (gerando um arquivo para cada uma).
#
# Autor: Pablo Picasso F. de Faria
# Em 12/11/2007
#

# Verifica parâmetros
if(scalar(@ARGV) != 1) {
   print "\nScripts do Corpus Tycho Brahe, IEL/Unicamp (2008)\n";
   print "Autor: Pablo Faria (pablofaria\@gmail.com)\n\n";
   print "Uso:\n    tb-splitPreparse.pl <file>\n";
   print "Saída:\n    <file>_s9999.txt\n\n";
   exit;
}

$fin = $ARGV[0];
open(ARQ, "<$fin") || die;

print "Processando...\n";

# Varre o arquivo, concatenando todas as linhas em um buffer
$buffer = "";
while($linha = <ARQ>) {
   $buffer .= $linha;
}

# Substitui quebras de linha por espaço em branco
$buffer =~ s/\n/ /g;

# Gera um arquivo separado para cada sentença
$ii = 1;
while ($buffer =~ /(\(\(.*?\)\)\))/) {
    $fout = $ARGV[0]."_s".sprintf("%05d",$ii).".txt";
    open(S_FILE, ">$fout") || die;
    # Imprime a nova linha no arquivo
    print S_FILE $1;
    close(S_FILE);
    $buffer =~ s/(\(\(.*?\)\)\))//;
    $ii += 1;
}

print "Ok!\n";
